/*
Hint, OnHint, GetLongHint example
This example uses a status bar, a menu, and an edit box on a form. Include a value for the Hint property for each menu item in the menu. Also, specify a value for the Hint property of the edit box. Align the status bar at the bottom of the form.
Declare the DisplayHint method as a public procedure of the Form:
*/ 
class TForm1 : public TForm
{
__published: // IDE-managed Components
private: // User declarations
public: // User declarations
  __fastcall TForm1(TComponent* Owner);
  void __fastcall DisplayHint(TObject *Sender);  // add this line
};
Here is the code to add to the unit file.  It provides the implementation of the DisplayHint method and assigns it to the Application in the forms OnCreate event handler.
Note:	It is not actually necessary to write an OnHint event handler to display hints on the status bar. This can be accomplished more simply by setting the status bars AutoHint property.
*) 
void __fastcall TForm1::DisplayHint(TObject *Sender)
{
  StatusBar1->SimpleText = GetLongHint(Application->Hint);
}
// Here is the forms OnCreate event handler.
// It assigns the applications OnHint event handler at runtime
// because the Application is not available in the Object Inspector 
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  Application->OnHint = DisplayHint;
} 
